Status: Resolved Priority: Should have
Author: David Greiner Category: IRRE
Created: 2014-03-19 Assigned To:
Updated: 2014-05-28 Due date:
TYPO3 Version: 6.1
PHP Version: 5.3
Complexity: medium
Is Regression: No
Sprint Focus:
Subject: Parent language is not applied to new child records
Description

Hi!

When creating a element in another language than the default language and adding a child element via IRRE, i am expecting that the
child element gets the same language as the parent element.

For instance a news element from tx_news:

    1. Create new news element and choose a language which is not defined as default 
    2. save
    3. add a media element via irre 
    4. now you have to select the language in the media element again

This behaviour is not very usable for editors.

Related issues:
related to Core - Bug # 48883: Wrong sys_language_uid in sys_file_reference New 2013-06-05
related to Core - Bug # 40656: t3lib_TCEforms_inline->createNewRecord doesn't... Resolved 2012-09-05
related to Core - Feature # 60026: Set explicitly 'readOnly' sys_language_uid... New 2014-07-01
duplicated by Core - Bug # 21964: New child records created from a translated... Closed 2010-01-15

Associated revisions
Revision cf9ca274 - 2014-05-28 14:11 - David Greiner

[BUGFIX] Parent language is not applied to new child records

If localizing a parent-child structure, usually the language
of the parent element shall be applied to related child records
as well as new child records.

Due to a missing array segment, the accordant section in the
the InlineElement source code never was processed.

Resolves: #57063
Releases: 6.2, 6.1
Change-Id: I7e563044f9889538f9b8171f71f7685722db8266
Reviewed-on: https://review.typo3.org/30448
Reviewed-by: Markus Klein
Reviewed-by: David Greiner
Reviewed-by: Wouter Wolters
Reviewed-by: Oliver Hader
Tested-by: Oliver Hader

Revision 3e6e8ec8 - 2014-05-28 14:12 - David Greiner

[BUGFIX] Parent language is not applied to new child records

If localizing a parent-child structure, usually the language
of the parent element shall be applied to related child records
as well as new child records.

Due to a missing array segment, the accordant section in the
the InlineElement source code never was processed.

Resolves: #57063
Releases: 6.2, 6.1
Change-Id: I7e563044f9889538f9b8171f71f7685722db8266
Reviewed-on: https://review.typo3.org/30472
Reviewed-by: Oliver Hader
Tested-by: Oliver Hader

History
#1 - 2014-04-09 11:55 - David Greiner
- File InlineElement.patch added

I think there is a bug in /typo3/sysext/backend/Classes/Form/Element/InlineElement.php

Defining

'behaviour' => array(
'localizationMode' => 'select',
...
),

should be neccessary since it is described in 
http://docs.typo3.org/typo3cms/TCAReference/Reference/Columns/Inline/Index.html#columns-inline-properties-behaviour

Adding this to the TCA configuration does not take effect cause of InlineElement.php:1223 checks for $config['localizationMode'] and not for
$config['behaviour']['localizationMode'].

This is what the attached patch updates.

The patch is for the current master branch (6.2) in https://git.typo3.org/Packages/TYPO3.CMS.git

#2 - 2014-04-09 13:52 - David Greiner
- File InlineElement_2nd.patch added
Second patch is better.

#3 - 2014-05-27 15:12 - Oliver Hader
- Status changed from New to Accepted
- Complexity set to medium

I'll have a look - thx for the patch!
Besides that, I could reproduce the misbehavior.

#4 - 2014-05-27 15:12 - Oliver Hader
- PHP Version set to 5.3

#5 - 2014-05-27 16:08 - Oliver Hader
- Subject changed from IRRE: Use localization of parent element to Parent language is not applied to child records

#6 - 2014-05-27 16:09 - Oliver Hader
- Subject changed from Parent language is not applied to child records to Parent language is not applied to new child records

#7 - 2014-05-27 16:16 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/30448

#8 - 2014-05-27 16:18 - Oliver Hader

David, I modified your patch a little bit, however it was the correct place and correct bug analysis! Good catch & thanks!

#9 - 2014-05-27 21:01 - David Greiner

Great. Thx for that :)

#10 - 2014-05-28 14:12 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-1 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/30472

#11 - 2014-05-28 14:19 - Teamgeist Medien

Just wasted a half day with handling the complications without this function working. Thanks alot!

#12 - 2014-05-28 14:30 - David Greiner
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100
Applied in changeset commit:3e6e8ec89c00b04485a3c6050e0cfdd9548a213e.

Files
InlineElement.patch 915 Bytes 2014-04-09 David Greiner
InlineElement_2nd.patch 973 Bytes 2014-04-09 David Greiner
